/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 12.02.2015
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments:


Chip type               : ATtiny13
AVR Core Clock frequency: 4.800000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>
#define DS  PORTB.0
#define SH_CP PORTB.2
#define ST_CP PORTB.3
#define BIT(bit)  (1<<(bit))

#define A 0b00000010
#define C 0b01000000
#define B 0b00000001
#define D 0b00100000
#define F 0b00001000
#define E 0b00010000
#define G 0b00000100

#define n0 A|B|C|D|E|F
#define n1 B|C
#define n2 A|B|G|E|D
#define n3 A|B|G|C|D
#define n4 B|C|F|G
#define n5 A|F|G|C|D
#define n6 A|F|E|D|C|G
#define n7 A|B|C
#define n8 A|B|C|D|E|F|G
#define n9 A|B|C|D|F|G

//     
           //      0   1   2   3   4   5   6   7   8   9  '  '  '-'
char digit[] =   {n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, 0x00, G};

volatile unsigned char imp = 0, count = 0, show = 0;
unsigned char display[2] = {11, 11};

//      
void write_data(unsigned char *data, unsigned char nbytes)
{
    unsigned char mask,i,j; 
    for(i = 0; i < nbytes; i++)
    {
      mask = 0x80;
      ST_CP = 0;            //   
      for(j = 0; j < 8; j++)
      {
//     
        if (data[i]&mask) DS = 1; else DS = 0;
        delay_us(5);    
        SH_CP = 0;
        delay_us(50);
        SH_CP = 1; 
        mask = mask >> 1;  //  
      }
    }
    ST_CP=1;	          //    
    delay_us(50); 
}

void print_defis(void)
{
  display[0] =  digit[11];
  display[1] =  digit[11];
  write_data(display,2);
}

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
  show = 0;
  if (imp<25) imp++;
}

void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Input/Output Ports initialization
// Port B initialization
PORTB=0x00;
DDRB=0x3D;

 // External Interrupt(s) initialization
GIMSK=0x40; // INT0: On
MCUCR=0x03; // INT0 Mode: Rising Edge
GIFR=0x40;  // Interrupt on any change on pins PCINT0-5: Off

print_defis();

// Global enable interrupts
#asm("sei")
while (1)
      {
        delay_ms(8);
        if (show<254)show++;
        #asm("cli") // 
        if ((imp>0)&&(imp==count))
        {
          imp=0;
          display[0] =  digit[count%10];
          if (count<10) 
          {
            display[1] =  digit[10];
          } else  
          {
            display[1] =  digit[count/10];   
          }; 
          write_data(display,2);
        } 
        if (show>50) print_defis();
        count = imp; 
        #asm("sei") //           
      }
      
      

}
